uqmi: ensure CID is a numeric value before proceeding
[openwrt/openwrt.git] / package / network / utils / uqmi / files / lib / netifd / proto / qmi.sh
old mode 100644 (file)
new mode 100755 (executable)
index 8ee7dbd..46ea134
@@ -15,27 +15,25 @@ proto_qmi_init_config() {
        proto_config_add_string username
        proto_config_add_string password
        proto_config_add_string pincode
-       proto_config_add_string delay
+       proto_config_add_int delay
        proto_config_add_string modes
-       proto_config_add_boolean ipv6
-       proto_config_add_boolean dhcp
+       proto_config_add_string pdptype
+       proto_config_add_int profile
+       proto_config_add_boolean dhcpv6
+       proto_config_add_boolean autoconnect
+       proto_config_add_int plmn
+       proto_config_add_defaults
 }
 
 proto_qmi_setup() {
        local interface="$1"
+       local dataformat connstat
+       local device apn auth username password pincode delay modes pdptype profile dhcpv6 autoconnect plmn $PROTO_DEFAULT_OPTIONS
+       local cid_4 pdh_4 cid_6 pdh_6
+       local ip_6 ip_prefix_length gateway_6 dns1_6 dns2_6
+       json_get_vars device apn auth username password pincode delay modes pdptype profile dhcpv6 autoconnect plmn $PROTO_DEFAULT_OPTIONS
 
-       local device apn auth username password pincode delay modes ipv6 dhcp
-       local cid_4 pdh_4 cid_6 pdh_6 ipv4
-       local ip subnet gateway dns1 dns2 ip_6 ip_prefix_length gateway_6 dns1_6 dns2_6
-       json_get_vars device apn auth username password pincode delay modes ipv6 dhcp
-
-       ipv4=1
-
-       if [ "$ipv6" = 0 ]; then
-               ipv6=""
-       else
-               ipv6=1
-       fi
+       [ "$metric" = "" ] && metric="0"
 
        [ -n "$ctl_device" ] && device=$ctl_device
 
@@ -45,6 +43,8 @@ proto_qmi_setup() {
                proto_set_available "$interface" 0
                return 1
        }
+
+       device="$(readlink -f $device)"
        [ -c "$device" ] || {
                echo "The specified control device does not exist"
                proto_notify_error "$interface" NO_DEVICE
@@ -65,11 +65,12 @@ proto_qmi_setup() {
        [ -n "$delay" ] && sleep "$delay"
 
        while uqmi -s -d "$device" --get-pin-status | grep '"UIM uninitialized"' > /dev/null; do
+               [ -e "$device" ] || return 1
                sleep 1;
        done
 
        [ -n "$pincode" ] && {
-               uqmi -s -d "$device" --verify-pin1 "$pincode" || {
+               uqmi -s -d "$device" --verify-pin1 "$pincode" > /dev/null || uqmi -s -d "$device" --uim-verify-pin1 "$pincode" > /dev/null || {
                        echo "Unable to verify PIN"
                        proto_notify_error "$interface" PIN_FAILED
                        proto_block_restart "$interface"
@@ -77,90 +78,156 @@ proto_qmi_setup() {
                }
        }
 
-       [ -n "$apn" ] || {
-               echo "No APN specified"
-               proto_notify_error "$interface" NO_APN
-               return 1
+       [ -n "$plmn" ] && {
+               local mcc mnc
+               if [ "$plmn" = 0 ]; then
+                       mcc=0
+                       mnc=0
+                       echo "Setting PLMN to auto"
+               else
+                       mcc=${plmn:0:3}
+                       mnc=${plmn:3}
+                       echo "Setting PLMN to $plmn"
+               fi
+               uqmi -s -d "$device" --set-plmn --mcc "$mcc" --mnc "$mnc" || {
+                       echo "Unable to set PLMN"
+                       proto_notify_error "$interface" PLMN_FAILED
+                       proto_block_restart "$interface"
+                       return 1
+               }
        }
 
+       # Cleanup current state if any
+       uqmi -s -d "$device" --stop-network 0xffffffff --autoconnect
+
+       # Set IP format
        uqmi -s -d "$device" --set-data-format 802.3
        uqmi -s -d "$device" --wda-set-data-format 802.3
+       dataformat="$(uqmi -s -d "$device" --wda-get-data-format)"
+
+       if [ "$dataformat" = '"raw-ip"' ]; then
+
+               [ -f /sys/class/net/$ifname/qmi/raw_ip ] || {
+                       echo "Device only supports raw-ip mode but is missing this required driver attribute: /sys/class/net/$ifname/qmi/raw_ip"
+                       return 1
+               }
+
+               echo "Device does not support 802.3 mode. Informing driver of raw-ip only for $ifname .."
+               echo "Y" > /sys/class/net/$ifname/qmi/raw_ip
+       fi
+
+       uqmi -s -d "$device" --sync
 
        echo "Waiting for network registration"
        while uqmi -s -d "$device" --get-serving-system | grep '"searching"' > /dev/null; do
+               [ -e "$device" ] || return 1
                sleep 5;
        done
 
        [ -n "$modes" ] && uqmi -s -d "$device" --set-network-modes "$modes"
 
-       echo "Starting network $apn"
+       echo "Starting network $interface"
 
-       cid_4=`uqmi -s -d "$device" --get-client-id wds`
-       [ $? -ne 0 ] && {
-               echo "Unable to obtain client ID"
-               proto_notify_error "$interface" NO_CID
-               return 1
-       }
+       pdptype=$(echo "$pdptype" | awk '{print tolower($0)}')
+       [ "$pdptype" = "ip" -o "$pdptype" = "ipv6" -o "$pdptype" = "ipv4v6" ] || pdptype="ip"
 
-       pdh_4=`uqmi -s -d "$device" --set-client-id wds,"$cid_4" \
-               --start-network "$apn" \
-               ${auth:+--auth-type $auth} \
-               ${username:+--username $username} \
-               ${password:+--password $password} \
-               --ip-family ipv4`
-       [ $? -ne 0 ] && {
-               echo "Unable to connect IPv4"
-               uqmi -s -d "$device" --set-client-id wds,"$cid_4" --release-client-id wds
-               ipv4=""
+       if [ "$pdptype" = "ip" ]; then
+               [ -z "$autoconnect" ] && autoconnect=1
+               [ "$autoconnect" = 0 ] && autoconnect=""
+       else
+               [ "$autoconnect" = 1 ] || autoconnect=""
+       fi
+
+       [ "$pdptype" = "ip" -o "$pdptype" = "ipv4v6" ] && {
+               cid_4=$(uqmi -s -d "$device" --get-client-id wds)
+               if ! [ "$cid_4" -eq "$cid_4" ] 2> /dev/null; then
+                       echo "Unable to obtain client ID"
+                       proto_notify_error "$interface" NO_CID
+                       return 1
+               fi
+
+               uqmi -s -d "$device" --set-client-id wds,"$cid_4" --set-ip-family ipv4 > /dev/null
+
+               pdh_4=$(uqmi -s -d "$device" --set-client-id wds,"$cid_4" \
+                       --start-network \
+                       ${apn:+--apn $apn} \
+                       ${profile:+--profile $profile} \
+                       ${auth:+--auth-type $auth} \
+                       ${username:+--username $username} \
+                       ${password:+--password $password} \
+                       ${autoconnect:+--autoconnect})
+
+        # pdh_4 is a numeric value on success
+               if ! [ "$pdh_4" -eq "$pdh_4" ] 2> /dev/null; then
+                       echo "Unable to connect IPv4"
+                       uqmi -s -d "$device" --set-client-id wds,"$cid_4" --release-client-id wds
+                       proto_notify_error "$interface" CALL_FAILED
+                       return 1
+               fi
+
+        # Check data connection state
+               connstat=$(uqmi -s -d "$device" --get-data-status)
+                [ "$connstat" == '"connected"' ] || {
+                        echo "No data link!"
+                        uqmi -s -d "$device" --set-client-id wds,"$cid_4" --release-client-id wds
+                        proto_notify_error "$interface" CALL_FAILED
+                        return 1
+                }
        }
 
-       [ -n "$ipv6" ] && {
-               cid_6=`uqmi -s -d "$device" --get-client-id wds`
-               if [ $? = 0 ]; then
-                       pdh_6=`uqmi -s -d "$device" --set-client-id wds,"$cid_6" \
-                               --start-network "$apn" \
-                               ${auth:+--auth-type $auth} \
-                               ${username:+--username $username} \
-                               ${password:+--password $password} \
-                               --ip-family ipv6`
-                       [ $? -ne 0 ] && {
-                               echo "Unable to connect IPv6"
-                               uqmi -s -d "$device" --set-client-id wds,"$cid_6" --release-client-id wds
-                               ipv6=""
-                       }
-               else
+       [ "$pdptype" = "ipv6" -o "$pdptype" = "ipv4v6" ] && {
+               cid_6=$(uqmi -s -d "$device" --get-client-id wds)
+               if ! [ "$cid_6" -eq "$cid_6" ] 2> /dev/null; then
+                       echo "Unable to obtain client ID"
+                       proto_notify_error "$interface" NO_CID
+                       return 1
+               fi
+
+               uqmi -s -d "$device" --set-client-id wds,"$cid_6" --set-ip-family ipv6 > /dev/null
+
+               pdh_6=$(uqmi -s -d "$device" --set-client-id wds,"$cid_6" \
+                       --start-network \
+                       ${apn:+--apn $apn} \
+                       ${profile:+--profile $profile} \
+                       ${auth:+--auth-type $auth} \
+                       ${username:+--username $username} \
+                       ${password:+--password $password} \
+                       ${autoconnect:+--autoconnect})
+
+        # pdh_6 is a numeric value on success
+               if ! [ "$pdh_6" -eq "$pdh_6" ] 2> /dev/null; then
                        echo "Unable to connect IPv6"
-                       ipv6=""
+                       uqmi -s -d "$device" --set-client-id wds,"$cid_6" --release-client-id wds
+                       proto_notify_error "$interface" CALL_FAILED
+                       return 1
                fi
-       }
 
-       [ -z "$ipv4" -a -z "$ipv6" ] && {
-               echo "Unable to connect"
-               proto_notify_error "$interface" CALL_FAILED
-               return 1
+        # Check data connection state
+               connstat=$(uqmi -s -d "$device" --get-data-status)
+                [ "$connstat" == '"connected"' ] || {
+                        echo "No data link!"
+                        uqmi -s -d "$device" --set-client-id wds,"$cid_6" --release-client-id wds
+                        proto_notify_error "$interface" CALL_FAILED
+                        return 1
+                }
        }
 
-       if [ -z "$dhcp" ]; then
-               echo "Setting up $ifname"
-               [ -n "$ipv4" ] && {
-                       json_load "$(uqmi -s -d $device --set-client-id wds,$cid_4 --get-current-settings)"
-                       json_select ipv4
-                       json_get_vars ip subnet gateway dns1 dns2
-
-                       proto_init_update "$ifname" 1
-                       proto_set_keep 1
-                       proto_add_ipv4_address "$ip" "$subnet"
-                       proto_add_dns_server "$dns1"
-                       proto_add_dns_server "$dns2"
-                       proto_add_ipv4_route "0.0.0.0" 0 "$gateway"
-                       proto_add_data
-                       json_add_string "cid_4" "$cid_4"
-                       json_add_string "pdh_4" "$pdh_4"
-                       proto_close_data
-                       proto_send_update "$interface"
-               }
-       
-               [ -n "$ipv6" ] && {
+       echo "Setting up $ifname"
+       proto_init_update "$ifname" 1
+       proto_set_keep 1
+       proto_add_data
+       [ -n "$pdh_4" ] && {
+               json_add_string "cid_4" "$cid_4"
+               json_add_string "pdh_4" "$pdh_4"
+       }
+       [ -n "$pdh_6" ] && {
+               json_add_string "cid_6" "$cid_6"
+               json_add_string "pdh_6" "$pdh_6"
+       }
+       proto_close_data
+       proto_send_update "$interface"
+       [ -n "$pdh_6" ] && {
+               if [ -z "$dhcpv6" -o "$dhcpv6" = 0 ]; then
                        json_load "$(uqmi -s -d $device --set-client-id wds,$cid_6 --get-current-settings)"
                        json_select ipv6
                        json_get_var ip_6 ip
@@ -171,54 +238,51 @@ proto_qmi_setup() {
 
                        proto_init_update "$ifname" 1
                        proto_set_keep 1
-                       # RFC 7278: Extend an IPv6 /64 Prefix to LAN
                        proto_add_ipv6_address "$ip_6" "128"
                        proto_add_ipv6_prefix "${ip_6}/${ip_prefix_length}"
                        proto_add_ipv6_route "$gateway_6" "128"
-                       proto_add_ipv6_route "::0" 0 "$gateway_6" "" "" "${ip_6}/${ip_prefix_length}"
-                       proto_add_dns_server "$dns1_6"
-                       proto_add_dns_server "$dns2_6"
-                       proto_add_data
-                       json_add_string "cid_6" "$cid_6"
-                       json_add_string "pdh_6" "$pdh_6"
-                       proto_close_data
+                       [ "$defaultroute" = 0 ] || proto_add_ipv6_route "::0" 0 "$gateway_6" "" "" "${ip_6}/${ip_prefix_length}"
+                       [ "$peerdns" = 0 ] || {
+                               proto_add_dns_server "$dns1_6"
+                               proto_add_dns_server "$dns2_6"
+                       }
                        proto_send_update "$interface"
-               }
-       else
-               echo "Starting DHCP on $ifname"
-               proto_init_update "$ifname" 1
-               proto_add_data
-               [ -n "$ipv4" ] && {
-                       json_add_string "cid_4" "$cid_4"
-                       json_add_string "pdh_4" "$pdh_4"
-               }
-               [ -n "$ipv6" ] && {
-                       json_add_string "cid_6" "$cid_6"
-                       json_add_string "pdh_6" "$pdh_6"
-               }
-               proto_close_data
-               proto_send_update "$interface"
-
-               [ -n "$ipv4" ] && {
-                       json_init
-                       json_add_string name "${interface}_4"
-                       json_add_string ifname "@$interface"
-                       json_add_string proto "dhcp"
-                       json_close_object
-                       ubus call network add_dynamic "$(json_dump)"
-               }
-
-               [ -n "$ipv6" ] && {
+               else
                        json_init
                        json_add_string name "${interface}_6"
                        json_add_string ifname "@$interface"
                        json_add_string proto "dhcpv6"
+                       proto_add_dynamic_defaults
                        # RFC 7278: Extend an IPv6 /64 Prefix to LAN
                        json_add_string extendprefix 1
                        json_close_object
                        ubus call network add_dynamic "$(json_dump)"
-               }
-       fi
+               fi
+       }
+
+       [ -n "$pdh_4" ] && {
+               json_init
+               json_add_string name "${interface}_4"
+               json_add_string ifname "@$interface"
+               json_add_string proto "dhcp"
+               proto_add_dynamic_defaults
+               json_close_object
+               ubus call network add_dynamic "$(json_dump)"
+       }
+}
+
+qmi_wds_stop() {
+       local cid="$1"
+       local pdh="$2"
+
+       [ -n "$cid" ] || return
+
+       uqmi -s -d "$device" --set-client-id wds,"$cid" \
+               --stop-network 0xffffffff \
+               --autoconnect > /dev/null
+
+       [ -n "$pdh" ] && uqmi -s -d "$device" --set-client-id wds,"$cid" --stop-network "$pdh"
+       uqmi -s -d "$device" --set-client-id wds,"$cid" --release-client-id wds
 }
 
 proto_qmi_teardown() {
@@ -229,24 +293,14 @@ proto_qmi_teardown() {
 
        [ -n "$ctl_device" ] && device=$ctl_device
 
-       echo "Stopping network"
+       echo "Stopping network $interface"
 
        json_load "$(ubus call network.interface.$interface status)"
        json_select data
        json_get_vars cid_4 pdh_4 cid_6 pdh_6
 
-       [ -n "$cid_4" ] && {
-               [ -n "$pdh_4" ] && {
-                       uqmi -s -d "$device" --set-client-id wds,"$cid_4" --stop-network "$pdh_4"
-                       uqmi -s -d "$device" --set-client-id wds,"$cid_4" --release-client-id wds
-               }
-       }
-       [ -n "$cid_6" ] && {
-               [ -n "$pdh_6" ] && {
-                       uqmi -s -d "$device" --set-client-id wds,"$cid_6" --stop-network "$pdh_6"
-                       uqmi -s -d "$device" --set-client-id wds,"$cid_6" --release-client-id wds
-               }
-       }
+       qmi_wds_stop "$cid_4" "$pdh_4"
+       qmi_wds_stop "$cid_6" "$pdh_6"
 
        proto_init_update "*" 0
        proto_send_update "$interface"